/* ---------------------------------------------------------- */
/*  pako_simple_app.cpp                                       */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - Foundation application class
    @author   rerofumi
    @since    Nov.04.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako_simple_app.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

//! fobO\͍͒`
#define DEBUGPRINT(FMT, ...)

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
PakoSimpleApp::PakoSimpleApp()
{
  /* --- member initialize */
  m_TargetMachine = 0;
  m_WindowSizeW = PAKO_FRAME_SIZE_W;
  m_WindowSizeH = PAKO_FRAME_SIZE_H;
  m_FrameRate = PAKO_FRAME_RATE;
  m_FrameSkipMode = 1;
  m_SkipRate = 0;
  m_AppCounter = 0;
}

/**
 * fXgN^(n)
 */
PakoSimpleApp::~PakoSimpleApp()
{
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- execute() */
/**
 * Q[{̂s郁\bh
 * ̃\bh̒Ŏs[vWJAQ[I܂
 * \bh𔲂Ȃ
 * {I[o[Ch͍lȂ
 *
 * @return IR(\)
 *
 */
int PakoSimpleApp::execute(void)
{
  int  i;
  int  rs;
  int endflag;
  bool endflag2;
  /* - ^CJEg */
  int  SystemTime;
  int  BeforeTiming;
  int  WorkTime;
  int  NowTiming;
  int  DispTime;

  /* --- O */
  rs = onBoot();
  /* - Ȃɂ珉Ɏs */
  if (rs != 0) {
    return(1);
  }
  /* --- AvP[VI */
  rs = onExecuteBefore();
  /* - Ȃɂ珉Ɏs */
  if (rs != 0) {
    return(1);
  }

  /* --- ^C~Ov */
  WorkTime = 0;
  SystemTime = SDL_GetTicks();
  BeforeTiming = SystemTime;
  DispTime = 0;
  m_AppCounter = 0;
  m_SkipRate = 0;
  /* --- ItO */
  endflag = 0;
  endflag2 = true;

  /* ---------------------------------------- */
  /* ----- C[`                     */
  /* ---------------------------------------- */
  while(endflag == 0) {
    /* --- Q[{̃[v */
    for(i=0; i<=m_SkipRate; i++) {
      m_AppCounter = m_AppCounter + 1;
      InputPoll();
      /* ------------------------------- */
      /* ----- Q[C */
      if (((endflag2 = tick()) == false) || (InputExit() != 0)) {
	BeforeTiming = SDL_GetTicks();
	break;
      }
    }

    /* ----- fobOpĎ */
    DEBUGPRINT("%d", m_AppCounter);
    DEBUGPRINT("Work Time : W%02d/D%02d/%d", WorkTime, DispTime, (1000/m_FrameRate));
    DEBUGPRINT("Frame Skip : %d", FrameSkip);
    DEBUGPRINT("Key Input : %x", InputJoyKey(0));

    WorkTime = SDL_GetTicks() - BeforeTiming;

    /* --- t[IAXN[` */
    if (tickDisplay() == false) {
      break;
    }
    swapFrameBuffer();

    /* --- t[^C}[ */
    DispTime = SDL_GetTicks() - BeforeTiming;
#ifdef NOTPSP
    NowTiming = (1000 / m_FrameRate) - WorkTime;
    if ((NowTiming > 0) && (NowTiming <= (1000 / m_FrameRate))) {
      SDL_Delay(NowTiming);
    }
    /* --- IĎ */
    endflag = InputExit();
    if (endflag2 == false) {
      endflag = 1;
    }
    /* --- t[XLbv[gvZ */
    if (m_FrameSkipMode == PAKO_FRAME_SKIP_DISPLAY) {
      m_SkipRate = DispTime / (1000 / m_FrameRate);
    }
    else {
      m_SkipRate = 0;
    }
#else
    m_SkipRate = 0;
#endif
    BeforeTiming = SDL_GetTicks();
    
    /* ----- C[vRR܂ */
  }  
  
  /* --- ㏈ */
  rs = onExecuteAfter();
  rs = onShutdown();
  /* --- ܂ */
  return(rs);
}


/* ----------------------------------------- */
/* --- onBoot() */
/**
 * execute ̓ŌĂяoO\bh
 * VXȅɎg
 * pŏڂǉĂ
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoSimpleApp::onBoot(void)
{
  int  r;

  /* ----- SDL  */
  r = SDL_Init(SDL_INIT_VIDEO |
	       SDL_INIT_AUDIO | 
	       SDL_INIT_TIMER |
	       SDL_INIT_JOYSTICK );
  if (r != 0) {
    /* --- SDLłȂ */
    return(1);
  }

  /* ----- SDLo͏ */
  InputInit();
  SoundInit();

  /* - - - ʕ\̏͌pɂ */

  return(0);
}


/* ----------------------------------------- */
/* --- onShutdown() */
/**
 * execute ̏IĂяo㏈\bh
 * VXe̔j
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoSimpleApp::onShutdown(void)
{
  /* --- IASDL ㏈ */
  SoundFree();
  InputFree();
  SDL_Quit();

  return(0);
}



/* ----------------------------------------- */
/* --- onExecuteBefore() */
/**
 * execute ̓ŌĂяoO\bh
 * Q[NX̏Ɏg
 * pŏڂǉĂ
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoSimpleApp::onExecuteBefore(void)
{
  return(0);
}


/* ----------------------------------------- */
/* --- onExecuteBefore() */
/**
 * execute ̏IĂяo㏈\bh
 * jڂȂp̂ɒǉ
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoSimpleApp::onExecuteAfter(void)
{
  return(0);
}


/* ----------------------------------------- */
/* --- sestFrameRate() */
/**
 * t[[gl fps Ŏw肷ANZT
 *
 * @param fps [in] t[[g̒l(l60)
 *
 */
void PakoSimpleApp::setFrameRate(int fps)
{
  m_FrameRate = fps;
}

/* ----------------------------------------- */
/* --- sestFrameRate() */
/**
 * dăt[XLbvKvȏꍇǂU镑̎w
 * PAKO_FRAME_SKIP_NONE = 0 t[XLbv
 * PAKO_FRAME_SKIP_DISPLAY = 1 t[XLbvL(l)
 *
 * @param mode [in] t[XLbṽ[h
 *
 */
void PakoSimpleApp::setFrameSkipMode(int mode)
{
  m_FrameSkipMode = mode;
}


/*------------------------------------------------------*/
/* private method                                       */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- tick() */
/**
 * t[ĂяoQ[{̃\bh
 * pŃI[o[ChĂɃQ[{̂Lq
 * 1t[̍ƂI烁\bh𔲂邱
 *
 * @return trueŒʏƒAfalseŃQ[I
 *
 */
bool PakoSimpleApp::tick(void)
{
  return true;
}


/* ----------------------------------------- */
/* --- tickDisplay() */
/**
 * t[Ăяoʕ\\bh
 * pŃI[o[ChĂɉʕ`揈Lq
 * tick()̒ɋLqĂǂA̓t[XLbv
 * ΂Ă΂Ȃ̂ŏ肭p
 *
 * @return trueŒʏƒAfalseŕ\ُ
 *
 */
bool PakoSimpleApp::tickDisplay(void)
{
  return true;
}


/* ----------------------------------------- */
/* --- swapFrameBuffer() */
/**
 * t[̍ŌŌĂяo郁\bh
 * tickDisplay()̒ɌĂ΂AۂɃt[obt@
 * ʂɕ\铮s
 * p̃foCXɉĎ
 *
 */
void PakoSimpleApp::swapFrameBuffer(void)
{
}

/*------------------------------------------------------*/
/* local method                                         */
/*------------------------------------------------------*/
