/* ---------------------------------------------------------- */
/*  pako_user_app.cpp                                         */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - user application class
    @author   rerofumi
    @since    Nov.08.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/
#include <math.h>

#include "pako_user_app.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
PakoUserApp::PakoUserApp()
{
}

/**
 * fXgN^(n)
 */
PakoUserApp::~PakoUserApp()
{
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/*------------------------------------------------------*/
/* private method                                       */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- onExecuteBefore() */
/**
 * s̏
 *
 * @return 0ŐIAȊOňُI
 *
 */
int PakoUserApp::onExecuteBefore(void)
{
  /* --- 60fps */
  setFrameRate(60);

  race = new Cave3dGame(this);
  retro = new Cave2dGame(this);
  title = new CaveTitle(this);

  readTexture(0, "texture1.png");

  step = 0;

  return(0);
}


/* ----------------------------------------- */
/* --- onExecuteAfter() */
/**
 * š㏈
 *
 * @return 0ŐIAȊOňُI
 *
 */
int PakoUserApp::onExecuteAfter(void)
{
  delete race;
  delete retro;
  delete title;
  return(0);
}

/* ----------------------------------------- */
/* --- tick() */
/**
 * t[ĂяoQ[{̃\bh
 * pŃI[o[ChĂɃQ[{̂Lq
 * 1t[̍ƂI烁\bh𔲂邱
 *
 * @return trueŒʏƒAfalseŃQ[I
 *
 */
bool PakoUserApp::tick(void)
{
  int next;

  switch(step) {
    /* -- N */
  case 0:
    /* - XvCgݒ */
    createSpriteLayer(1, 64, 1);
    title->initalizeGame();
    step = 1;
    break;

    /* -- ^Cg */
  case 1:
    title->tick();
    if ((next = title->getState()) != 0) {
      if (next == 1) {
	race->initalizeGame();
	step = 2;
      }
      else {
	retro->initalizeGame();
	step = 3;
      }
    }
    break;

    /* -- 3D version */
  case 2:
    race->tick();
    if (race->getState() != 0) {
      /* - ^Cgɖ߂ */
      title->initalizeGame();
      step = 1;
    }
    break;

    /* -- 2D version */
  case 3:
    retro->tick();
    if (retro->getState() != 0) {
      /* - ^Cgɖ߂ */
      title->initalizeGame();
      step = 1;
    }
    break;

  }

  return true;
}


/* ----------------------------------------- */
/* --- tickDisplay() */
/**
 * t[Ăяoʕ\\bh
 * pŃI[o[ChĂɉʕ`揈Lq
 * tick()̒ɋLqĂǂA̓t[XLbv
 * ΂Ă΂Ȃ̂ŏ肭p
 *
 * @return trueŒʏƒAfalseŕ\ُ
 *
 */
bool PakoUserApp::tickDisplay(void)
{
  float  view_x, view_y;

  /* -- ʃNA */
  glClearColor(0.0, 0.0, 0.0, 1.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glDepthMask(GL_TRUE);
  glEnable(GL_DEPTH_TEST);
  /* -- world ݒ */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  if (m_WindowSizeW > m_WindowSizeH) {
    view_x = tan(3.1415926353 / 2 * (60.0 / 180.0));
    view_y = tan(3.1415926353 / 2 *
		 (((60.0 / 180.0) * m_WindowSizeH) / m_WindowSizeW));
  }
  else {
    view_y = tan(3.1415926353 / 2 * (60.0 / 180.0));
    view_x = tan(3.1415926353 / 2 *
		 (((60.0 / 180.0) * m_WindowSizeW) / m_WindowSizeH));
  }
  glFrustum(-view_x/2, view_x/2, -view_y/2, view_y/2, 1.0, 200.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glCullFace( GL_BACK );
  glFrontFace( GL_CCW );
  glEnable( GL_CULL_FACE );

  /* --- [h */
  switch(step) {
  case 1:
    title->tickDisplay();
    break;
  case 2:
    race->tickDisplay();
    break;
  case 3:
    retro->tickDisplay();
    break;
  default:
    break;
  }

  /* -- XvCg\ */
  displaySprite();

  return true;
}
